#include "c_msg.h"

static char buf[MAX_MSG_LEN+2];
static int last_index = -1;
static int last_lang = -1;

typedef struct {
	char e_msg[MAX_MSG_LEN+1];
	char k_msg[MAX_MSG_LEN+1];
} msg_t;

msg_t msg[N_MSG] = {
	{"--MORE--", "----" },
	{"No boards to select.", " Ѱ ..."},
	{"Cannot Zap.", " ȵ˴ϴ."},
	{"Vist failed.", " 湮 ߾."},
	{"Visit in progress...", " 湮.. ѷ~  Ҳ..."},
	{"Done!", " !"},
	{"A board must have a name.", "̸ ־."},
	{"Board already exists.", " ѹ ʾ..̹ ־~"},
	{"Invalid board name.", " ϱ ׷  ."},
	{"Board not added.", "  ߾."},
	{"Deleting board.", " ﲨ."},
	{"Board not deleted.", "  ."},
	{"Board deleted.", " ."},
	{"Board deletion failed.", " ."},
	{"Board not changed.", "  ٲ."},
	{"Board changed.", " ٲϴ."},
	{"Board change failed.", " ٲٴµ ߾"},
	{"Unknown error.", ".. !"}
};

void c_msg(int index, int eol)
{
	extern int lang;

	if (index < 0 || index >= N_MSG)
		index = UNKNOWN;
	if (last_index == -1 || last_index != index ||
		last_lang == -1 || last_lang != lang)
	{
		if (lang)
		{
			if (eol)
				sprintf(buf, "%s\n", msg[index].k_msg);
			else
				strcpy(buf, msg[index].k_msg);
		}
		else
		{
			if (eol)
				sprintf(buf, "%s\n", msg[index].e_msg);
			else
				strcpy(buf, msg[index].e_msg);
		}
		last_index = index;
		last_lang = lang;
	}
	prints(buf);
}
