
/*
	Too slow.

	Rewrote using new name.c

	Daeshik Kim

	dkim@hq.si.net
	hellcat@korea.slip.umd.edu
*/


/*
Eagles Bulletin Board System
Copyright (C) 1994, Ray Rocker, rrrocker@rock.b11.ingr.com
                                rock@seabass.st.usm.edu
                                72673.2105@compuserve.com

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
   Adapted from Pirates BBS 1.8, namecomplete.c
   Copyright (C) 1990, Edward Luke, lush@Athena.EE.MsState.EDU
*/

#include "client.h"
#include <ctype.h>
#include <malloc.h>

#define WORDSIZE NAMELEN+1

static int NumInList(list)
NAMELIST list;
{
  return  (list->last);
}

ListMaxLen(list, lines)
NAMELIST list;
int lines;
{
/*
  register NAMENODE *ptr;
  register int i, size, len, max = 0;

  for (i=0, size=list->last, ptr=list->data; i<size; i++) {
    len = strlen (ptr[i].word);
    if (len > max) max = len;
  }
  return max;
*/
  return NAMELEN;
}

chkstr(tag,name)
char *tag, *name;
{
  register char c1, c2;
  while(*tag != '\0') {
    c1 = *tag++;
    c2 = *name++;
    if (c1 == c2) continue;
    if (myislower(c1)) c1 = toupper(c1);
    if (myislower(c2)) c2 = toupper(c2);
    if(c1 != c2)
      return 0;
  }
  return 1;
}

NAMELIST
GetSubList(tag, list)
register char *tag ;
register NAMELIST list;
{
  NAMELIST wlist;
  register NAMENODE *ptr;
  register int i, size;

  wlist = NULL;
  create_namelist (&wlist, MAXUSER);
  for (i=0, size=list->last, ptr=list->data; i<size; i++)
    {
      if (tag == NULL)
	add_namelist(&wlist, ptr[i].word, NULL);
      else
	{
	  if (chkstr(tag, ptr[i].word))
	    add_namelist(&wlist, ptr[i].word, NULL);
	}
    }
  sort_list(&wlist);
  return (wlist);
}

static void ClearSubList(list)
NAMELIST list;
{
  free_namelist(&list);
}

#define NUMLINES (t_lines-6)

namecomplete(list, prompt, data)
NAMELIST list;
char *prompt, *data ;
{
  NAMENODE dummynode;
  char *temp;
  int ch ;
  int count = 0 ;
  int clearbot = 0;
  int i;
  
  if(scrint) {
    NAMELIST cwlist, morelist ;
    NAMENODE *ptr;
    int x,y ;
    int origx, origy;
    int total = 0, size = 0;
    int more = 0;
    int j;
    
    if(prompt != NULL) {
      prints("%s",prompt) ;
      clrtoeol() ;
    }
    temp = data ;
    
    if (list == NULL) {
      create_namelist (&list, 1);
      add_namelist(&list, "", NULL);
    }    
    cwlist = GetSubList(NULL, list) ;
    morelist = NULL ;
    getyx(&y,&x) ;
    getyx(&origy, &origx);
    
    while((ch = igetch()) != EOF)
      {
	if(ch == '\n' || ch == '\r') {
	  *temp = '\0' ;
	  prints("\n") ;
	  if(NumInList(cwlist) == 1 && temp != data)
	    strncpy(data,cwlist->data[0].word,WORDSIZE) ;
	  ClearSubList(cwlist) ;
	  break ;
	}
	if(ch == ' ') {
	  int col,len;

	  if(NumInList(cwlist) == 1) {
	    strncpy(data,cwlist->data[0].word,WORDSIZE) ;
	    move(origy,origx) ;
	    prints("%s",data) ;
	    count = strlen(data) ;
	    temp = data + count ;
	    getyx(&y,&x) ;
	    continue ;
	  }

	  clearbot = 1 ;
	  col = 0 ;

	  /* new! or everything is displayed the, we have to recycle this */
	  if((!morelist) || (total && size && total == size)) {
	    morelist = cwlist ;
	    ptr = morelist->data;
	    size = morelist->last;
	    total = 0;
	    len = ListMaxLen(morelist,NUMLINES) ;
	  }
	  move(4,0) ;
	  clrtobot();
	  standout() ;
	  for (i=0, j=(t_columns-18)/2; i<j; i++)
	    prints("-");
	  prints(" Completion List ");
	  for (i+=18, j=t_columns-1; i<j; i++)
	    prints("-");
	  standend() ;

	  while(len+col < t_columns-1) {
	    register int j;

	    for (j=0; total < size && j < NUMLINES; j++, total++) {
		move (5+j, col);
		prints("%s", ptr[total].word);
	    }
	    col += len+2 ;
	    if(total == size)
	      break;
	    len = ListMaxLen(morelist,NUMLINES) ;
	  }
	  if(total < size) {
	    extern int lang;

	    move(t_lines - 1, 0) ;
	    standout() ;
	    if (lang)
		prints("--  --") ;
	    else
		prints("-- More --") ;
	    standend() ;
	  }
	  refresh();
	  move(y,x) ;
	  continue ;
	}
	if(ch == '\177' || ch == '\010') {
	  if(temp == data)
	    continue ;
	  temp-- ;
	  count-- ;
	  *temp = '\0' ;
	  ClearSubList(cwlist) ;
	  cwlist = GetSubList(data,list) ;
	  morelist = NULL ;
	  ptr = NULL;
	  x-- ;
	  move(y,x) ;
	  addch(' ') ;
	  move(y,x) ;
	  continue ;
	}
	if(count < WORDSIZE) {
	  NAMELIST node ;
	  *temp++ = ch ;
	  count++ ;
	  *temp = '\0' ;
	  node = GetSubList(data,cwlist) ;
	  if(node == NULL) {
	    bell() ;
	    temp-- ;
	    *temp = '\0' ;
	    count-- ;
	    continue ;
	  }
	  ClearSubList(cwlist) ;
	  cwlist = node ;
	  morelist = NULL ;
	  ptr = NULL;
	  move(y,x) ;
	  addch(ch) ;
	  x++ ;
	}
      }
    if(ch == EOF)
      generic_abort() ;
    if (*data) {
      move(origy,origx);
      prints("%s", data);
    }
    prints("\n") ;
    refresh() ;
    if(clearbot) {
      move(2,0) ;
      clrtobot() ;
      move(3,0) ;
    }
    return 0 ;
  }
  if(prompt != NULL) {
    printf("%s",prompt) ;
    fflush(stdout) ;
  }
  if(!fgets(data,WORDSIZE,stdin))
    generic_abort() ;
  data[WORDSIZE] = '\0';
  if(temp = strchr(data,'\n'))
    *temp = '\0' ;
  return 0 ;
}
